<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd" >
<mapper namespace="com.bw.adv.module.order.mapper.OrderHeaderMapper">
	<resultMap id="BaseResultMap" type="com.bw.adv.module.order.model.OrderHeader">
		<id column="ORDER_ID" jdbcType="BIGINT" property="orderId" />
		<result column="ORDER_CODE" jdbcType="VARCHAR" property="orderCode" />
		<result column="EXTERNAL_ID" jdbcType="VARCHAR" property="externalId" />
		<result column="ORDER_TYPE_ID" jdbcType="BIGINT" property="orderTypeId" />
		<result column="MEMBER_ID" jdbcType="BIGINT" property="memberId" />
		<result column="CHANNEL_ID" jdbcType="BIGINT" property="channelId" />
		<result column="STORE_ID" jdbcType="BIGINT" property="storeId" />
		<result column="STORE_CODE" jdbcType="VARCHAR" property="storeCode" />
		<result column="ORDER_DATE" jdbcType="CHAR" property="orderDate" />
		<result column="FIRST_ATTEMPT_ORDER_ID" jdbcType="BIGINT"
			property="firstAttemptOrderId" />
		<result column="LAST_ATTEMPT_ORDER_ID" jdbcType="BIGINT"
			property="lastAttemptOrderId" />
		<result column="TABLE_FOR" jdbcType="BIGINT" property="tableFor" />
		<result column="EATING_STYLE_ENUM_ID" jdbcType="BIGINT"
			property="eatingStyleEnumId" />
		<result column="ORDER_AMOUNT" jdbcType="DECIMAL" property="orderAmount" />
		<result column="COUPON_AMOUNT" jdbcType="DECIMAL" property="couponAmount" />
		<result column="PAY_AMOUNT" jdbcType="DECIMAL" property="payAmount" />
		<result column="DELIVERY_AMOUNT" jdbcType="DECIMAL" property="deliveryAmount" />
		<result column="USED_POINTS" jdbcType="DECIMAL" property="usedPoints" />
		<result column="STAFF_ID" jdbcType="BIGINT" property="staffId" />
		<result column="STAFF_NAME" jdbcType="VARCHAR" property="staffName" />
		<result column="HAPPEN_TIME" jdbcType="CHAR" property="happenTime" />
		<result column="CREATE_TIME" jdbcType="CHAR" property="createTime" />
		<result column="LAST_MODIFIED_STAFF_ID" jdbcType="BIGINT"
			property="lastModifiedStaffId" />
		<result column="LAST_MODIFIED_STAFF_NAME" jdbcType="VARCHAR"
			property="lastModifiedStaffName" />
		<result column="LAST_MODIFIED_TIME" jdbcType="CHAR" property="lastModifiedTime" />
		<result column="STATUS_ID" jdbcType="BIGINT" property="statusId" />
		<result column="ORDER_DESC" property="orderDesc" jdbcType="VARCHAR" />
		<result column="USE_INFO" property="useInfo" jdbcType="VARCHAR" />
		<result column="GET_INFO" property="getInfo" jdbcType="VARCHAR" />
		<result column="REMARK" property="remark" jdbcType="VARCHAR" />
		<result column="FIELD1" property="field1" jdbcType="VARCHAR" />
		<result column="FIELD2" property="field2" jdbcType="VARCHAR" />
		<result column="FIELD3" property="field3" jdbcType="VARCHAR" />
		<result column="FIELD4" property="field4" jdbcType="VARCHAR" />
		<result column="FIELD5" property="field5" jdbcType="VARCHAR" />
		<result column="FIELD6" property="field6" jdbcType="VARCHAR" />
		<result column="FIELD7" property="field7" jdbcType="VARCHAR" />
		<result column="FIELD8" property="field8" jdbcType="VARCHAR" />
		<result column="FIELD9" property="field9" jdbcType="VARCHAR" />
		<result column="FIELD10" property="field10" jdbcType="VARCHAR" />
	</resultMap>

	<resultMap id="ExpMap"
		type="com.bw.adv.module.order.model.exp.OrderHeaderExp">
		<id column="ORDER_ID" property="orderId" jdbcType="BIGINT" />
		<result column="ORDER_CODE" property="orderCode" jdbcType="VARCHAR" />
		<result column="EXTERNAL_ID" property="externalId" jdbcType="VARCHAR" />
		<result column="ORDER_TYPE_ID" property="orderTypeId" jdbcType="BIGINT" />
		<result column="MEMBER_ID" property="memberId" jdbcType="BIGINT" />
		<result column="CHANNEL_ID" property="channelId" jdbcType="BIGINT" />
		<result column="STORE_ID" property="storeId" jdbcType="BIGINT" />
		<result column="ORDER_DATE" property="orderDate" jdbcType="CHAR" />
		<result column="FIRST_ATTEMPT_ORDER_ID" property="firstAttemptOrderId"
			jdbcType="BIGINT" />
		<result column="LAST_ATTEMPT_ORDER_ID" property="lastAttemptOrderId"
			jdbcType="BIGINT" />
		<result column="TABLE_FOR" property="tableFor" jdbcType="BIGINT" />
		<result column="EATING_STYLE_ENUM_ID" property="eatingStyleEnumId"
			jdbcType="BIGINT" />
		<result column="ORDER_AMOUNT" property="orderAmount" jdbcType="DECIMAL" />
		<result column="COUPON_AMOUNT" property="couponAmount"
			jdbcType="DECIMAL" />
		<result column="PAY_AMOUNT" property="payAmount" jdbcType="DECIMAL" />
		<result column="DELIVERY_AMOUNT" property="deliveryAmount"
			jdbcType="DECIMAL" />
		<result column="USED_POINTS" property="usedPoints" jdbcType="DECIMAL" />
		<result column="STAFF_ID" property="staffId" jdbcType="BIGINT" />
		<result column="STAFF_NAME" property="staffName" jdbcType="VARCHAR" />
		<result column="HAPPEN_TIME" property="happenTime" jdbcType="CHAR" />
		<result column="CREATE_TIME" property="createTime" jdbcType="CHAR" />
		<result column="USE_INFO" property="useInfo" jdbcType="VARCHAR" />
		<result column="GET_INFO" property="getInfo" jdbcType="VARCHAR" />
		<result column="LAST_MODIFIED_STAFF_ID" property="lastModifiedStaffId"
			jdbcType="BIGINT" />
		<result column="LAST_MODIFIED_STAFF_NAME" property="lastModifiedStaffName"
			jdbcType="VARCHAR" />
		<result column="LAST_MODIFIED_TIME" property="lastModifiedTime"
			jdbcType="CHAR" />
		<result column="STATUS_ID" property="statusId" jdbcType="BIGINT" />
		<result column="MEMBER_CODE" property="memberCode" jdbcType="BIGINT" />
		<result column="STORE_NAME" property="storeName" jdbcType="VARCHAR" />
		<result column="CHANNEL_NAME" property="channelName" jdbcType="VARCHAR" />
		<result column="COUPON_NAME" property="couponName" jdbcType="VARCHAR" />
		<result column="MOBILE" property="mobile" jdbcType="VARCHAR" />
	</resultMap>

	<sql id="Base_Column_List">
		ORDER_ID, ORDER_CODE, EXTERNAL_ID, ORDER_TYPE_ID, MEMBER_ID, CHANNEL_ID,
		STORE_ID,
		STORE_CODE, ORDER_DATE, FIRST_ATTEMPT_ORDER_ID, LAST_ATTEMPT_ORDER_ID, TABLE_FOR,
		EATING_STYLE_ENUM_ID, ORDER_AMOUNT, COUPON_AMOUNT, PAY_AMOUNT,
		DELIVERY_AMOUNT, USED_POINTS,
		STAFF_ID, STAFF_NAME, HAPPEN_TIME, CREATE_TIME, LAST_MODIFIED_STAFF_ID,
		LAST_MODIFIED_STAFF_NAME,
		LAST_MODIFIED_TIME, STATUS_ID, ORDER_DESC, USE_INFO, GET_INFO, REMARK, FIELD1, FIELD2,
		FIELD3,
		FIELD4, FIELD5, FIELD6, FIELD7, FIELD8, FIELD9, FIELD10
	</sql>

	<sql id="Exp_Column_List">
		oh.ORDER_ID, oh.ORDER_CODE, oh.EXTERNAL_ID, oh.ORDER_TYPE_ID, oh.MEMBER_ID,
		oh.CHANNEL_ID, oh.STORE_ID,
		oh.ORDER_DATE, oh.FIRST_ATTEMPT_ORDER_ID, oh.LAST_ATTEMPT_ORDER_ID, oh.TABLE_FOR,
		oh.EATING_STYLE_ENUM_ID,
		oh.ORDER_AMOUNT, oh.COUPON_AMOUNT, oh.PAY_AMOUNT, oh.DELIVERY_AMOUNT, oh.USED_POINTS,
		oh.STAFF_ID,
		oh.STAFF_NAME,oh.HAPPEN_TIME, oh.CREATE_TIME, oh.LAST_MODIFIED_STAFF_ID,
		oh.LAST_MODIFIED_STAFF_NAME, oh.LAST_MODIFIED_TIME,
		oh.STATUS_ID, oh.USE_INFO, oh.GET_INFO, mem.MEMBER_CODE,st.STORE_NAME,mem.MOBILE
	</sql>
	<sql id="OrderExp_Column_List">
		oh.ORDER_ID, oh.ORDER_CODE, oh.EXTERNAL_ID, oh.ORDER_TYPE_ID, oh.MEMBER_ID,
		oh.CHANNEL_ID, oh.STORE_ID,
		oh.ORDER_DATE, oh.FIRST_ATTEMPT_ORDER_ID, oh.LAST_ATTEMPT_ORDER_ID, oh.TABLE_FOR,
		oh.EATING_STYLE_ENUM_ID,
		oh.ORDER_AMOUNT, oh.COUPON_AMOUNT, oh.PAY_AMOUNT, oh.DELIVERY_AMOUNT, oh.USED_POINTS,
		oh.STAFF_ID,
		oh.STAFF_NAME, oh.CREATE_TIME, oh.LAST_MODIFIED_STAFF_ID,
		oh.LAST_MODIFIED_STAFF_NAME, oh.LAST_MODIFIED_TIME,
		oh.STATUS_ID, oh.USE_INFO, oh.GET_INFO, mem.MEMBER_CODE,c.COUPON_NAME,st.STORE_NAME
	</sql>

	<sql id="Example_Where_Clause">
		<where>
			<foreach collection="example.oredCriteria" item="criteria"
				separator="or">
				<if test="criteria.valid">
					<trim prefix="(" suffix=")" prefixOverrides="and">
						<foreach collection="criteria.criteria" item="criterion">
							<choose>
								<when test="criterion.noValue">
									and ${criterion.condition}
								</when>
								<when test="criterion.singleValue">
									and ${criterion.condition} '${criterion.value}'
								</when>
								<when test="criterion.betweenValue">
									and ${criterion.condition} '${criterion.value}' and
									'${criterion.secondValue}'
								</when>
								<when test="criterion.listValue">
									and ${criterion.condition}
									<foreach collection="criterion.value" item="listItem"
										open="(" close=")" separator=",">
										${listItem}
									</foreach>
								</when>
							</choose>
						</foreach>
					</trim>
				</if>
			</foreach>
		</where>
	</sql>
	<sql id="Example_Having_Clause">
		<where>
			<foreach collection="example.oredCriteria" item="criteria"
				separator="or">
				<if test="criteria.valid">
					<trim prefix="(" suffix=")" prefixOverrides="and">
						<foreach collection="criteria.criteria" item="criterion">
							<choose>
								<when test="criterion.noValue">
									and ${criterion.condition}
								</when>
								<when test="criterion.singleValue">
									and ${criterion.condition} '${criterion.value}'
								</when>
								<when test="criterion.betweenValue">
									and ${criterion.condition} '${criterion.value}' and
									'${criterion.secondValue}'
								</when>
								<when test="criterion.listValue">
									and ${criterion.condition}
									<foreach collection="criterion.value" item="listItem"
										open="(" close=")" separator=",">
										${listItem}
									</foreach>
								</when>
							</choose>
						</foreach>
					</trim>
				</if>
			</foreach>
		</where>
	</sql>

	<select id="selectExpByExample" resultMap="ExpMap"
		parameterType="Example">
		select
		<include refid="Exp_Column_List" />
		from order_header oh
		left join member mem on oh.member_id = mem.member_id
		left join store st on oh.STORE_ID = st.STORE_ID
		<if test="_parameter != null">
			<include refid="Example_Where_Clause" />
		</if>
		order by order_date desc,order_code desc
	</select>

	<select id="selectOrderExpByExample" resultMap="ExpMap"
		parameterType="Example">
		select
		<include refid="OrderExp_Column_List" />
		from order_header oh
		left join member mem on oh.member_id = mem.member_id
		left join store st on oh.STORE_ID = st.STORE_ID
		left join order_coupon oc on oh.order_id=oc.order_id
		left join coupon_instance ci on
		oc.coupon_instance_id=ci.coupon_instance_id
		left join coupon c on ci.coupon_id=c.coupon_id
		<if test="_parameter != null">
			<include refid="Example_Where_Clause" />
		</if>
		order by order_date desc,order_code desc
	</select>
	<select id="selectOrderExpByExa" resultType="orderHeaderExp"
		parameterType="java.lang.String">
		select oh.ORDER_ID as orderId, oh.ORDER_CODE as orderCode, oh.EXTERNAL_ID as
		externalId, oh.ORDER_TYPE_ID as orderTypeId,
		oh.MEMBER_ID as memberId, oh.CHANNEL_ID as channelId, oh.STORE_ID as storeId,
		oh.ORDER_DATE as orderDate, oh.FIRST_ATTEMPT_ORDER_ID as
		firstAttempOrderId, oh.LAST_ATTEMPT_ORDER_ID as lastAttemptOrderId,
		oh.TABLE_FOR as tableFor, oh.EATING_STYLE_ENUM_ID as
		eatingStyleEnumId,
		oh.ORDER_AMOUNT as orderAmount, oh.COUPON_AMOUNT as couponAmount, oh.PAY_AMOUNT as
		payAmount, oh.DELIVERY_AMOUNT as deliveryAmount,
		oh.USED_POINTS as usedPoints, oh.STAFF_ID as staffId,
		oh.STAFF_NAME as staffName, oh.CREATE_TIME as createTime, oh.LAST_MODIFIED_STAFF_ID
		as lastModifiedStaffId,
		oh.LAST_MODIFIED_STAFF_NAME as lastModifiedStaffName, oh.LAST_MODIFIED_TIME as lastModifiedTime,
		oh.STATUS_ID as statusId,mem.MEMBER_CODE as memberCode,st.STORE_NAME
		as storeName,group_concat(c.COUPON_NAME) as couponName
		from order_header oh
		left join member mem on oh.member_id = mem.member_id
		left join store st on oh.STORE_ID = st.STORE_ID
		left join order_coupon oc on oh.order_id=oc.order_id
		left join coupon_instance ci on
		oc.coupon_instance_id=ci.coupon_instance_id
		left join coupon c on ci.coupon_id=c.coupon_id group by oh.ORDER_ID
		having mem.MEMBER_CODE=${memberCode}
	</select>
	<select id="selectOrderPoints" resultType="orderHeaderExp"
		parameterType="java.lang.Long">
		select
		sum(mpi.ITEM_POINTS_NUMBER) as itemPointsNumber,oh.ORDER_ID as orderId
		from
		order_header oh inner join member_points_item mpi on oh.ORDER_ID = mpi.ORDER_ID
		where oh.ORDER_ID=${orderId}
	</select>
	<select id="selectOrderCoupon" resultType="orderHeaderExp"
		parameterType="java.lang.Long">
		select group_concat(c.COUPON_NAME) as usedCoupon
		from
		order_header oh inner join coupon_instance ci on oh.ORDER_ID=ci.ORDER_ID
		left join coupon c on ci.COUPON_ID = c.COUPON_ID
		where oh.ORDER_ID=${orderId}
	</select>
	<select id="selectOrderExpListByExa" resultType="orderHeaderExp"
		parameterType="Example">
		select ol.*,op.itemPointsNumber as itemPointsNumber,oc.usedCoupon as
		usedCoupon
		from (select oh.ORDER_ID as orderId, oh.ORDER_CODE as orderCode,
		oh.EXTERNAL_ID as externalId, oh.ORDER_TYPE_ID as orderTypeId,
		oh.MEMBER_ID as memberId, oh.CHANNEL_ID as channelId, oh.STORE_ID as
		storeId,
		oh.ORDER_DATE as orderDate, oh.FIRST_ATTEMPT_ORDER_ID as firstAttempOrderId,
		oh.LAST_ATTEMPT_ORDER_ID as lastAttemptOrderId,
		oh.TABLE_FOR as tableFor, oh.EATING_STYLE_ENUM_ID as eatingStyleEnumId,
		oh.ORDER_AMOUNT as orderAmount, oh.COUPON_AMOUNT as couponAmount,
		oh.PAY_AMOUNT as payAmount, oh.DELIVERY_AMOUNT as deliveryAmount,
		oh.USED_POINTS as usedPoints, oh.STAFF_ID as staffId,
		oh.STAFF_NAME as staffName, oh.CREATE_TIME as createTime, oh.LAST_MODIFIED_STAFF_ID
		as lastModifiedStaffId,
		oh.LAST_MODIFIED_STAFF_NAME as lastModifiedStaffName, oh.LAST_MODIFIED_TIME as lastModifiedTime,
		oh.STATUS_ID as statusId,mem.MEMBER_CODE as memberCode,st.STORE_NAME
		as storeName,group_concat(c.COUPON_NAME) as couponName
		from order_header oh
		left join member mem on oh.member_id = mem.member_id
		left join store st on oh.STORE_ID = st.STORE_ID
		left join order_coupon oc on oh.order_id=oc.order_id
		left join coupon_instance ci on
		oc.coupon_instance_id=ci.coupon_instance_id
		left join coupon c on ci.coupon_id=c.coupon_id group by oh.ORDER_ID) ol
		left join (select sum(mpi.ITEM_POINTS_NUMBER) as
		itemPointsNumber,oh.ORDER_ID as orderId
		from order_header oh
		inner join member_points_item mpi on oh.ORDER_ID = mpi.ORDER_ID group by
		oh.ORDER_ID)op on ol.orderId=op.orderId
		left join (select group_concat(c.COUPON_NAME) as usedCoupon,oh.ORDER_ID as
		orderId
		from order_header oh inner join coupon_instance ci on
		oh.ORDER_ID=ci.ORDER_ID
		left join coupon c on ci.COUPON_ID = c.COUPON_ID group by oh.ORDER_ID)oc
		on oc.orderId=ol.orderId
		<if test="_parameter != null">
			<include refid="Example_Where_Clause" />
		</if>
		order by ol.orderDate desc,ol.orderCode desc
	</select>
	<select id="selectOrderExpListByExample" resultType="orderHeaderExp"
		parameterType="Example">
		select oh.ORDER_ID as orderId, oh.ORDER_CODE as orderCode,
		oh.EXTERNAL_ID as externalId, oh.ORDER_TYPE_ID as orderTypeId,
		oh.MEMBER_ID as memberId, oh.CHANNEL_ID as channelId, oh.STORE_ID as
		storeId,
		oh.ORDER_DATE as orderDate, oh.FIRST_ATTEMPT_ORDER_ID as firstAttempOrderId,
		oh.LAST_ATTEMPT_ORDER_ID as lastAttemptOrderId,
		oh.TABLE_FOR as tableFor, oh.EATING_STYLE_ENUM_ID as eatingStyleEnumId,
		oh.ORDER_AMOUNT as orderAmount, oh.COUPON_AMOUNT as couponAmount,
		oh.PAY_AMOUNT as payAmount, oh.DELIVERY_AMOUNT as deliveryAmount,
		oh.USED_POINTS as usedPoints, oh.STAFF_ID as staffId,oh.HAPPEN_TIME as
		happenTime,
		oh.STAFF_NAME as staffName, oh.CREATE_TIME as createTime, oh.LAST_MODIFIED_STAFF_ID
		as lastModifiedStaffId,
		oh.LAST_MODIFIED_STAFF_NAME as lastModifiedStaffName, oh.LAST_MODIFIED_TIME as
		lastModifiedTime,oh.GET_INFO as getInfo,oh.USE_INFO as useInfo,
		oh.STATUS_ID as statusId,mem.MEMBER_CODE as memberCode,st.STORE_NAME
		as storeName
		from order_header oh
		left join member mem on oh.member_id = mem.member_id
		left join store st on oh.STORE_ID = st.STORE_ID
		<if test="_parameter != null">
			<include refid="Example_Where_Clause" />
		</if>
		order by oh.HAPPEN_TIME desc,oh.ORDER_CODE desc
	</select>
	<select id="selectByPrimaryKey" resultMap="BaseResultMap"
		parameterType="java.lang.Long">
		select
		<include refid="Base_Column_List" />
		from order_header
		where ORDER_ID = #{orderId,jdbcType=BIGINT}
	</select>
	<delete id="deleteByPrimaryKey" parameterType="java.lang.Long">
		delete from order_header
		where ORDER_ID = #{orderId,jdbcType=BIGINT}
	</delete>

	<insert id="insert" useGeneratedKeys="true" keyProperty="orderId"
		parameterType="com.bw.adv.module.order.model.OrderHeader">
		insert into order_header (ORDER_ID, ORDER_CODE, EXTERNAL_ID,
		ORDER_TYPE_ID, MEMBER_ID, CHANNEL_ID,
		STORE_ID, STORE_CODE, ORDER_DATE,
		FIRST_ATTEMPT_ORDER_ID, LAST_ATTEMPT_ORDER_ID,
		TABLE_FOR, EATING_STYLE_ENUM_ID, ORDER_AMOUNT,
		COUPON_AMOUNT, PAY_AMOUNT, DELIVERY_AMOUNT,
		USED_POINTS, STAFF_ID, STAFF_NAME,
		HAPPEN_TIME, CREATE_TIME, LAST_MODIFIED_STAFF_ID,
		LAST_MODIFIED_STAFF_NAME, LAST_MODIFIED_TIME, STATUS_ID,
		ORDER_DESC, USE_INFO,GET_INFO, REMARK,
		FIELD1, FIELD2, FIELD3,
		FIELD4, FIELD5, FIELD6,
		FIELD7, FIELD8, FIELD9,
		FIELD10)
		values (#{orderId,jdbcType=BIGINT}, #{orderCode,jdbcType=VARCHAR},
		#{externalId,jdbcType=VARCHAR},
		#{orderTypeId,jdbcType=BIGINT}, #{memberId,jdbcType=BIGINT}, #{channelId,jdbcType=BIGINT},
		#{storeId,jdbcType=BIGINT}, #{storeCode,jdbcType=VARCHAR},
		#{orderDate,jdbcType=CHAR},
		#{firstAttemptOrderId,jdbcType=BIGINT}, #{lastAttemptOrderId,jdbcType=BIGINT},
		#{tableFor,jdbcType=BIGINT}, #{eatingStyleEnumId,jdbcType=BIGINT},
		#{orderAmount,jdbcType=DECIMAL},
		#{couponAmount,jdbcType=DECIMAL}, #{payAmount,jdbcType=DECIMAL}, #{deliveryAmount,jdbcType=DECIMAL},
		#{usedPoints,jdbcType=DECIMAL}, #{staffId,jdbcType=BIGINT},
		#{staffName,jdbcType=VARCHAR},
		#{happenTime,jdbcType=CHAR}, #{createTime,jdbcType=CHAR}, #{lastModifiedStaffId,jdbcType=BIGINT},
		#{lastModifiedStaffName,jdbcType=VARCHAR},
		#{lastModifiedTime,jdbcType=CHAR}, #{statusId,jdbcType=BIGINT},
		#{orderDesc,jdbcType=VARCHAR},
		#{useInfo,jdbcType=VARCHAR},#{getInfo,jdbcType=VARCHAR},
		#{remark,jdbcType=VARCHAR},
		#{field1,jdbcType=VARCHAR}, #{field2,jdbcType=VARCHAR}, #{field3,jdbcType=VARCHAR},
		#{field4,jdbcType=VARCHAR}, #{field5,jdbcType=VARCHAR},
		#{field6,jdbcType=VARCHAR},
		#{field7,jdbcType=VARCHAR}, #{field8,jdbcType=VARCHAR}, #{field9,jdbcType=VARCHAR},
		#{field10,jdbcType=VARCHAR})
	</insert>
	<insert id="insertSelective" useGeneratedKeys="true"
		keyProperty="orderId" parameterType="com.bw.adv.module.order.model.OrderHeader">
		insert into order_header
		<trim prefix="(" suffix=")" suffixOverrides=",">
			<if test="orderId != null">
				ORDER_ID,
			</if>
			<if test="orderCode != null">
				ORDER_CODE,
			</if>
			<if test="externalId != null">
				EXTERNAL_ID,
			</if>
			<if test="orderTypeId != null">
				ORDER_TYPE_ID,
			</if>
			<if test="memberId != null">
				MEMBER_ID,
			</if>
			<if test="channelId != null">
				CHANNEL_ID,
			</if>
			<if test="storeId != null">
				STORE_ID,
			</if>
			<if test="storeCode != null">
				STORE_CODE,
			</if>
			<if test="orderDate != null">
				ORDER_DATE,
			</if>
			<if test="firstAttemptOrderId != null">
				FIRST_ATTEMPT_ORDER_ID,
			</if>
			<if test="lastAttemptOrderId != null">
				LAST_ATTEMPT_ORDER_ID,
			</if>
			<if test="tableFor != null">
				TABLE_FOR,
			</if>
			<if test="eatingStyleEnumId != null">
				EATING_STYLE_ENUM_ID,
			</if>
			<if test="orderAmount != null">
				ORDER_AMOUNT,
			</if>
			<if test="couponAmount != null">
				COUPON_AMOUNT,
			</if>
			<if test="payAmount != null">
				PAY_AMOUNT,
			</if>
			<if test="deliveryAmount != null">
				DELIVERY_AMOUNT,
			</if>
			<if test="usedPoints != null">
				USED_POINTS,
			</if>
			<if test="staffId != null">
				STAFF_ID,
			</if>
			<if test="staffName != null">
				STAFF_NAME,
			</if>
			<if test="happenTime != null">
				HAPPEN_TIME,
			</if>
			<if test="createTime != null">
				CREATE_TIME,
			</if>
			<if test="lastModifiedStaffId != null">
				LAST_MODIFIED_STAFF_ID,
			</if>
			<if test="lastModifiedStaffName != null">
				LAST_MODIFIED_STAFF_NAME,
			</if>
			<if test="lastModifiedTime != null">
				LAST_MODIFIED_TIME,
			</if>
			<if test="statusId != null">
				STATUS_ID,
			</if>
			<if test="orderDesc != null">
				ORDER_DESC,
			</if>
			<if test="useInfo != null">
				USE_INFO,
			</if>
			<if test="getInfo != null">
				GET_INFO,
			</if>
			<if test="remark != null">
				REMARK,
			</if>
			<if test="field1 != null">
				FIELD1,
			</if>
			<if test="field2 != null">
				FIELD2,
			</if>
			<if test="field3 != null">
				FIELD3,
			</if>
			<if test="field4 != null">
				FIELD4,
			</if>
			<if test="field5 != null">
				FIELD5,
			</if>
			<if test="field6 != null">
				FIELD6,
			</if>
			<if test="field7 != null">
				FIELD7,
			</if>
			<if test="field8 != null">
				FIELD8,
			</if>
			<if test="field9 != null">
				FIELD9,
			</if>
			<if test="field10 != null">
				FIELD10,
			</if>
		</trim>
		<trim prefix="values (" suffix=")" suffixOverrides=",">
			<if test="orderId != null">
				#{orderId,jdbcType=BIGINT},
			</if>
			<if test="orderCode != null">
				#{orderCode,jdbcType=VARCHAR},
			</if>
			<if test="externalId != null">
				#{externalId,jdbcType=VARCHAR},
			</if>
			<if test="orderTypeId != null">
				#{orderTypeId,jdbcType=BIGINT},
			</if>
			<if test="memberId != null">
				#{memberId,jdbcType=BIGINT},
			</if>
			<if test="channelId != null">
				#{channelId,jdbcType=BIGINT},
			</if>
			<if test="storeId != null">
				#{storeId,jdbcType=BIGINT},
			</if>
			<if test="storeCode != null">
				#{storeCode,jdbcType=VARCHAR},
			</if>
			<if test="orderDate != null">
				#{orderDate,jdbcType=CHAR},
			</if>
			<if test="firstAttemptOrderId != null">
				#{firstAttemptOrderId,jdbcType=BIGINT},
			</if>
			<if test="lastAttemptOrderId != null">
				#{lastAttemptOrderId,jdbcType=BIGINT},
			</if>
			<if test="tableFor != null">
				#{tableFor,jdbcType=BIGINT},
			</if>
			<if test="eatingStyleEnumId != null">
				#{eatingStyleEnumId,jdbcType=BIGINT},
			</if>
			<if test="orderAmount != null">
				#{orderAmount,jdbcType=DECIMAL},
			</if>
			<if test="couponAmount != null">
				#{couponAmount,jdbcType=DECIMAL},
			</if>
			<if test="payAmount != null">
				#{payAmount,jdbcType=DECIMAL},
			</if>
			<if test="deliveryAmount != null">
				#{deliveryAmount,jdbcType=DECIMAL},
			</if>
			<if test="usedPoints != null">
				#{usedPoints,jdbcType=DECIMAL},
			</if>
			<if test="staffId != null">
				#{staffId,jdbcType=BIGINT},
			</if>
			<if test="staffName != null">
				#{staffName,jdbcType=VARCHAR},
			</if>
			<if test="happenTime != null">
				#{happenTime,jdbcType=CHAR},
			</if>
			<if test="createTime != null">
				#{createTime,jdbcType=CHAR},
			</if>
			<if test="lastModifiedStaffId != null">
				#{lastModifiedStaffId,jdbcType=BIGINT},
			</if>
			<if test="lastModifiedStaffName != null">
				#{lastModifiedStaffName,jdbcType=VARCHAR},
			</if>
			<if test="lastModifiedTime != null">
				#{lastModifiedTime,jdbcType=CHAR},
			</if>
			<if test="statusId != null">
				#{statusId,jdbcType=BIGINT},
			</if>
			<if test="orderDesc != null">
				#{orderDesc,jdbcType=VARCHAR},
			</if>
			<if test="useInfo != null">
				#{useInfo,jdbcType=VARCHAR},
			</if>
			<if test="getInfo != null">
				#{getInfo,jdbcType=VARCHAR},
			</if>
			<if test="remark != null">
				#{remark,jdbcType=VARCHAR},
			</if>
			<if test="field1 != null">
				#{field1,jdbcType=VARCHAR},
			</if>
			<if test="field2 != null">
				#{field2,jdbcType=VARCHAR},
			</if>
			<if test="field3 != null">
				#{field3,jdbcType=VARCHAR},
			</if>
			<if test="field4 != null">
				#{field4,jdbcType=VARCHAR},
			</if>
			<if test="field5 != null">
				#{field5,jdbcType=VARCHAR},
			</if>
			<if test="field6 != null">
				#{field6,jdbcType=VARCHAR},
			</if>
			<if test="field7 != null">
				#{field7,jdbcType=VARCHAR},
			</if>
			<if test="field8 != null">
				#{field8,jdbcType=VARCHAR},
			</if>
			<if test="field9 != null">
				#{field9,jdbcType=VARCHAR},
			</if>
			<if test="field10 != null">
				#{field10,jdbcType=VARCHAR},
			</if>
		</trim>
	</insert>
	<update id="updateByPrimaryKeySelective" parameterType="com.bw.adv.module.order.model.OrderHeader">
		update order_header
		<set>
			<if test="orderCode != null">
				ORDER_CODE = #{orderCode,jdbcType=VARCHAR},
			</if>
			<if test="externalId != null">
				EXTERNAL_ID = #{externalId,jdbcType=VARCHAR},
			</if>
			<if test="orderTypeId != null">
				ORDER_TYPE_ID = #{orderTypeId,jdbcType=BIGINT},
			</if>
			<if test="memberId != null">
				MEMBER_ID = #{memberId,jdbcType=BIGINT},
			</if>
			<if test="channelId != null">
				CHANNEL_ID = #{channelId,jdbcType=BIGINT},
			</if>
			<if test="storeId != null">
				STORE_ID = #{storeId,jdbcType=BIGINT},
			</if>
			<if test="storeCode != null">
				STORE_CODE = #{storeCode,jdbcType=VARCHAR},
			</if>
			<if test="orderDate != null">
				ORDER_DATE = #{orderDate,jdbcType=CHAR},
			</if>
			<if test="firstAttemptOrderId != null">
				FIRST_ATTEMPT_ORDER_ID = #{firstAttemptOrderId,jdbcType=BIGINT},
			</if>
			<if test="lastAttemptOrderId != null">
				LAST_ATTEMPT_ORDER_ID = #{lastAttemptOrderId,jdbcType=BIGINT},
			</if>
			<if test="tableFor != null">
				TABLE_FOR = #{tableFor,jdbcType=BIGINT},
			</if>
			<if test="eatingStyleEnumId != null">
				EATING_STYLE_ENUM_ID = #{eatingStyleEnumId,jdbcType=BIGINT},
			</if>
			<if test="orderAmount != null">
				ORDER_AMOUNT = #{orderAmount,jdbcType=DECIMAL},
			</if>
			<if test="couponAmount != null">
				COUPON_AMOUNT = #{couponAmount,jdbcType=DECIMAL},
			</if>
			<if test="payAmount != null">
				PAY_AMOUNT = #{payAmount,jdbcType=DECIMAL},
			</if>
			<if test="deliveryAmount != null">
				DELIVERY_AMOUNT = #{deliveryAmount,jdbcType=DECIMAL},
			</if>
			<if test="usedPoints != null">
				USED_POINTS = #{usedPoints,jdbcType=DECIMAL},
			</if>
			<if test="staffId != null">
				STAFF_ID = #{staffId,jdbcType=BIGINT},
			</if>
			<if test="staffName != null">
				STAFF_NAME = #{staffName,jdbcType=VARCHAR},
			</if>
			<if test="happenTime != null">
				HAPPEN_TIME = #{happenTime,jdbcType=CHAR},
			</if>
			<if test="createTime != null">
				CREATE_TIME = #{createTime,jdbcType=CHAR},
			</if>
			<if test="lastModifiedStaffId != null">
				LAST_MODIFIED_STAFF_ID = #{lastModifiedStaffId,jdbcType=BIGINT},
			</if>
			<if test="lastModifiedStaffName != null">
				LAST_MODIFIED_STAFF_NAME = #{lastModifiedStaffName,jdbcType=VARCHAR},
			</if>
			<if test="lastModifiedTime != null">
				LAST_MODIFIED_TIME = #{lastModifiedTime,jdbcType=CHAR},
			</if>
			<if test="statusId != null">
				STATUS_ID = #{statusId,jdbcType=BIGINT},
			</if>
			<if test="orderDesc != null">
				ORDER_DESC = #{orderDesc,jdbcType=VARCHAR},
			</if>
			<if test="useInfo != null">
				USE_INFO = #{useInfo,jdbcType=VARCHAR},
			</if>
			<if test="getInfo != null">
				GET_INFO = #{getInfo,jdbcType=VARCHAR},
			</if>
			<if test="remark != null">
				REMARK = #{remark,jdbcType=VARCHAR},
			</if>
			<if test="field1 != null">
				FIELD1 = #{field1,jdbcType=VARCHAR},
			</if>
			<if test="field2 != null">
				FIELD2 = #{field2,jdbcType=VARCHAR},
			</if>
			<if test="field3 != null">
				FIELD3 = #{field3,jdbcType=VARCHAR},
			</if>
			<if test="field4 != null">
				FIELD4 = #{field4,jdbcType=VARCHAR},
			</if>
			<if test="field5 != null">
				FIELD5 = #{field5,jdbcType=VARCHAR},
			</if>
			<if test="field6 != null">
				FIELD6 = #{field6,jdbcType=VARCHAR},
			</if>
			<if test="field7 != null">
				FIELD7 = #{field7,jdbcType=VARCHAR},
			</if>
			<if test="field8 != null">
				FIELD8 = #{field8,jdbcType=VARCHAR},
			</if>
			<if test="field9 != null">
				FIELD9 = #{field9,jdbcType=VARCHAR},
			</if>
			<if test="field10 != null">
				FIELD10 = #{field10,jdbcType=VARCHAR},
			</if>
		</set>
		where ORDER_ID = #{orderId,jdbcType=BIGINT}
	</update>
	<update id="updateByPrimaryKey" parameterType="com.bw.adv.module.order.model.OrderHeader">
		update order_header
		set ORDER_CODE = #{orderCode,jdbcType=VARCHAR},
		EXTERNAL_ID = #{externalId,jdbcType=VARCHAR},
		ORDER_TYPE_ID = #{orderTypeId,jdbcType=BIGINT},
		MEMBER_ID = #{memberId,jdbcType=BIGINT},
		CHANNEL_ID = #{channelId,jdbcType=BIGINT},
		STORE_ID = #{storeId,jdbcType=BIGINT},
		STORE_CODE = #{storeCode,jdbcType=VARCHAR},
		ORDER_DATE = #{orderDate,jdbcType=CHAR},
		FIRST_ATTEMPT_ORDER_ID = #{firstAttemptOrderId,jdbcType=BIGINT},
		LAST_ATTEMPT_ORDER_ID = #{lastAttemptOrderId,jdbcType=BIGINT},
		TABLE_FOR = #{tableFor,jdbcType=BIGINT},
		EATING_STYLE_ENUM_ID = #{eatingStyleEnumId,jdbcType=BIGINT},
		ORDER_AMOUNT = #{orderAmount,jdbcType=DECIMAL},
		COUPON_AMOUNT = #{couponAmount,jdbcType=DECIMAL},
		PAY_AMOUNT = #{payAmount,jdbcType=DECIMAL},
		DELIVERY_AMOUNT = #{deliveryAmount,jdbcType=DECIMAL},
		USED_POINTS = #{usedPoints,jdbcType=DECIMAL},
		STAFF_ID = #{staffId,jdbcType=BIGINT},
		STAFF_NAME = #{staffName,jdbcType=VARCHAR},
		HAPPEN_TIME = #{happenTime,jdbcType=CHAR},
		CREATE_TIME = #{createTime,jdbcType=CHAR},
		LAST_MODIFIED_STAFF_ID = #{lastModifiedStaffId,jdbcType=BIGINT},
		LAST_MODIFIED_STAFF_NAME = #{lastModifiedStaffName,jdbcType=VARCHAR},
		LAST_MODIFIED_TIME = #{lastModifiedTime,jdbcType=CHAR},
		STATUS_ID = #{statusId,jdbcType=BIGINT},
		ORDER_DESC = #{orderDesc,jdbcType=VARCHAR},
		USE_INFO = #{useInfo,jdbcType=VARCHAR},
		GET_INFO = #{getInfo,jdbcType=VARCHAR},
		REMARK = #{remark,jdbcType=VARCHAR},
		FIELD1 = #{field1,jdbcType=VARCHAR},
		FIELD2 = #{field2,jdbcType=VARCHAR},
		FIELD3 = #{field3,jdbcType=VARCHAR},
		FIELD4 = #{field4,jdbcType=VARCHAR},
		FIELD5 = #{field5,jdbcType=VARCHAR},
		FIELD6 = #{field6,jdbcType=VARCHAR},
		FIELD7 = #{field7,jdbcType=VARCHAR},
		FIELD8 = #{field8,jdbcType=VARCHAR},
		FIELD9 = #{field9,jdbcType=VARCHAR},
		FIELD10 = #{field10,jdbcType=VARCHAR}
		where ORDER_ID = #{orderId,jdbcType=BIGINT}
	</update>

	<select id="queryOrderByConditions" resultMap="BaseResultMap">
		select
		<include refid="Base_Column_List" />
		from order_header
		where MEMBER_ID = #{memberId,jdbcType=BIGINT} or ORDER_AMOUNT =
		#{orderAmount,jdbcType=DECIMAL}
		or CREATE_TIME = #{createTime,jdbcType=CHAR} or ORDER_CODE =
		#{orderCode,jdbcType=VARCHAR} or STATUS_ID =
		#{statusId,jdbcType=BIGINT}
	</select>


	<select id="selectByExternalId" resultMap="BaseResultMap">
		select
		<include refid="Base_Column_List" />
		from order_header
		where external_Id = '${externalId}'
	</select>


	<select id="selectByExternalIdForDayNumber" resultMap="BaseResultMap">
		select
		<include refid="Base_Column_List" />
		from order_header h
		where h.external_Id = #{0}
		and h.happen_Time >= #{1}
	</select>

	<select id="showShopOrderCount" resultType="orderHeaderExp"
		parameterType="java.lang.String">
		select oh.ORDER_AMOUNT as orderAmount,(oh.ORDER_AMOUNT - oh.PAY_AMOUNT) as
		payAmount,
		oh.USED_POINTS as usedPoints,oh.CREATE_TIME as createTime,m.MOBILE
		from order_header oh
		join member m on oh.MEMBER_ID = m.MEMBER_ID
		where CREATE_TIME like '${date}%'
		and STORE_CODE = '${storeCode}'
	</select>

	<select id="queryCountByAmountAndMemberId" resultType="java.lang.Long">
		select count(1) from (
		select ORDER_ID
		from order_header
		where MEMBER_ID = #{memberId}
		and order_date like CONCAT(EXTRACT(YEAR_MONTH FROM #{orderDate}),"%")
		GROUP BY ORDER_DATE
		HAVING SUM(ORDER_AMOUNT) >= #{amount})tmp
	</select>
	
	<select id="queryEveryDayOrderAmount" resultType="java.math.BigDecimal">
		select sum(ORDER_AMOUNT) from order_header
		where MEMBER_ID = #{memberId}
		and ORDER_DATE = #{orderDate}
	</select>
	
</mapper>
